
% Input:  The function values of a 2pi-periodic function f:[0,2pi] ---> IC
%         u(j) = f(x_j),   x_j=j*2pi/N,   j=0, ..., L-1
%         L=2*mumax+1 (must be odd!)
% Output: The Fourier coefficients fhat such that
%         f(x_j) = sum_{mu=-mumax}^{mumax} fhat(mu)*exp(i*mu*x_j)
%         out(k) = fhat(-mumax-1+k),   k=1, ..., L

function v = myfft(u)

L=length(u);
if rem(L-1,2)>0
    fprintf('\n\n\n')
    error('     L must be odd!!! ')
else
    mumax=round((L-1)/2);
end

v=fft(u);
v=fftshift(v);
v=v/L;

if 0
    % Check result
    x=2*pi*[0:L-1]'/L;
    uu=zeros(L,1);
    for mu=-mumax:mumax
        uu=uu+v(mu+mumax+1)*exp(i*mu*x);   
    end
    norm(u-uu)    
end

% ccc; N=201; v=(rand(N,1)-0.5)+i*(rand(N,1)-0.5); u = myifft(v); vv = myfft(u); norm(v-vv,inf)