
% Input:  The Fourier coefficients fhat such that
%         f(x_j) = sum_{mu=-mumax}^{mumax} fhat(mu)*exp(i*mu*x_j)
%         out(k) = fhat(-mumax-1+k),   k=1, ..., L
% Output: The function values of the 2pi-periodic function f:[0,2pi] ---> IR
%         u(j) = f(x_j),   x_j=j*2pi/N,   j=0, ..., L-1
%         L=2*mumax+1 (must be odd!)

function u = myifft(v)

L=length(v);
if rem(L-1,2)>0
    fprintf('\n\n\n')
    error('     L must be odd!!! ')
else
    mumax=round((L-1)/2);
end

v=v*L;
v=ifftshift(v);
u=ifft(v);

if 0
    % Check result
    ccc;
    mumax=200;
    L=2*mumax+1;
    x=2*pi*[0:L-1]'/L;
    for mu=-mumax:mumax
        u=exp(i*mu*x);
        v = myfft(u);
        uu = myifft(v);
        norm(u-uu,inf)
        if norm(u-uu,inf)>1e-10; keyboard; end
        
    end
    
    
    
    
end

